import java.awt.Desktop;
import java.io.File;
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.*;
import java.awt.geom.*;
import javax.swing.*;
import java.awt.*;

 
public final class CKT1 
{
	JTextArea area = new JTextArea(24,24);
	JScrollPane scrollingArea;
	ArrayList<Resistor> rlist = new ArrayList<Resistor>();
 
    	public void start() 
	{
        	scrollingArea = new JScrollPane(area);
		area.setBorder(BorderFactory.createEmptyBorder(4, 4, 4, 4));
		area.setEditable(false);
		Font font = new Font("Verdana", Font.PLAIN, 14);
		area.setFont(font);
		Solver s = new Solver(area);
		s.rlist = rlist;
		s.SolveCircuit();
	}	



     public void read_circuit(String filename)
     { 
		try (BufferedReader br = new BufferedReader(new FileReader(filename));) 
		{
			String CurrentLine;

			while ((CurrentLine = br.readLine()) != null) 
			{
				//Split each line of text file
				String delims = "[ ]+";
 				String[] tokens = (CurrentLine.trim().split(delims));
				if (tokens[0].equals("R")) {
					Resistor r = new Resistor(tokens);
					rlist.add(r);
					area.append(r + "\n");
				}					
			 }
			 br.close(); 
		 } 		
		 catch (IOException e) 
		{
			System.out.println(e);
		}
    	}


    public static void main(String[] args)
    {
		CKT1 panel = new CKT1();

 		// Chooses the file
 		JFileChooser fc = new JFileChooser(System.getProperty("user.dir"));

        	File file = null;
       		if (args.length>0) file = new File(args[0]);

       		if (file == null) {
			int returnVal = fc.showOpenDialog(null);
        		if (returnVal == JFileChooser.APPROVE_OPTION) {
                		file = fc.getSelectedFile();
			}
		}
		if (file == null) System.exit(-1);
		String filename = file.getName();
		panel.read_circuit(filename);
		panel.start();

        EventQueue.invokeLater(() -> {
		JFrame frame = new JFrame("CKT1");
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.add(panel.scrollingArea);
		frame.pack();
		frame.setVisible(true);
	});
    }
 }