// VoltageSource

import javafx.scene.Group;
import javafx.scene.Scene;
import javafx.scene.*;
import javafx.scene.paint.*;
import javafx.scene.shape.*;
import javafx.scene.input.* ;
import javafx.collections.*;
import javafx.geometry.Point2D;

public class VoltageSource  {
	String name;
	int n1, n2;
	double value;
	double xpos, ypos;
	double angle;
	Color clr;

    VoltageSource()
    {
	clr = Color.BLACK;
	xpos = 0.0;
	ypos = 0.0;
	angle = 0.0;
	
    }

    VoltageSource(String [] tokens) {
	if (tokens.length>4) {
		name = tokens[1];
		n1 = Integer.parseInt(tokens[2]);
		n2 = Integer.parseInt(tokens[3]);
		value = Double.parseDouble(tokens[4]);
	}
	if (tokens.length>6) {
		xpos = Double.parseDouble(tokens[5]);
		ypos = Double.parseDouble(tokens[6]);
	}
	if (tokens.length>7) angle = Double.parseDouble(tokens[7]);
	clr = Color.BLACK;
   }

   public String toString() {
	return "V " + name + " " + n1 + " " + n2 + " " + value + " " + xpos + " " + ypos + " " + angle;
   }


    public void setAngle(double angle)
    {
	this.angle = angle;
    }

   public void setPosition(double x, double y) {
	xpos = x;
	ypos = y;
   }

   public void draw(Graphics g;) {
	double resc = 0.1;
	grp.setScaleX(resc);
	grp.setScaleY(resc);
	Rectangle rb = new Rectangle(-2.5,-1.5,5.0,3.0);
	rb.setFill(Color.TRANSPARENT);

	double res = parent.getScaleX();
	Path p = new Path();
	ObservableList<PathElement> pl = p.getElements();
	double [] xp = { 0.5, 0.7, 0.9 };
	double [] yp = { 1.3, 1.4, 1.5 };
	pl.add(new MoveTo(-2.5,0.0));
	pl.add(new LineTo(-0.5,0.0));
	pl.add(new MoveTo(-0.5,-1.5));
	pl.add(new LineTo(-0.5,1.5));

	pl.add(new MoveTo(0.5,-1.0));
	pl.add(new LineTo(0.5, 1.0));
	pl.add(new CubicCurveTo(xp[0],yp[0],xp[1],yp[1],xp[2],yp[2]));
	pl.add(new MoveTo(0.5,-1.0));
	pl.add(new CubicCurveTo(xp[0],-yp[0],xp[1],-yp[1],xp[2],-yp[2]));

	pl.add(new MoveTo(0.5,0.0));
	pl.add(new LineTo(2.5,0.0));

	ObservableList<Node> ol = grp.getChildren();
	p.setStrokeWidth(20/res);
	p.setStroke(clr);
 	p.setStrokeLineCap(StrokeLineCap.ROUND);
    }
}
